unit main;

{$ifdef fpc}
  {$MODE Delphi}
{$endif}

interface

uses
  {$ifdef fpc}
    LCLIntf,
    LCLType,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  DelTime,
  WolfUtil,
  StdCtrls;

type
  TMainForm = class(TForm)
    Memo    : TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Ausgabe(ThisYear : Integer; Date : tJulianDay; Bias : Double);
  end;

var
  MainForm: TMainForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

procedure TMainForm.Ausgabe(ThisYear : Integer; Date : tJulianDay;
                            Bias : Double);
  var     Day   : Double;
          Month : Word;
          Year  : Integer;
          s     : String;
  begin
    Year  := 1;
    Month := 1;
    Day   := 1;
    LocalJulianDate(Date, Year, Month, Day);
    if Year = ThisYear then
      begin
        s := IntToStr(Round(Bias * 24 * 60));
        Memo.Lines.add(LocalJulianFormatDateTime('ddd dd MMM yyyy '
                                                 + GetLongTimeFormat, Date)
                       + ', Bias ' + StringOfChar(' ', 5 - length(s)) + s);
      end;
  end;

procedure TMainForm.FormCreate(Sender: TObject);
  var     DayLightDate1,
          DoubleSummerDate,
          DayLightDate2,
          StandardDate      : tJulianDay;
          DaylightBias,
          DoubleSummerBias,
          StandardBias      : Double;
          Year              : Integer;
  begin
    Memo.align       := alClient;
    DayLightDate1    := 0;
    DoubleSummerDate := 0;
    DayLightDate2    := 0;
    StandardDate     := 0;
    DaylightBias     := 0;
    DoubleSummerBias := 0;
    StandardBias     := 0;
    For Year := 1916 to 2037 do
      begin
        GetDayLightDates(Year, DayLightDate1, DoubleSummerDate, DayLightDate2,
                               StandardDate,
                               DaylightBias,  DoubleSummerBias, StandardBias);
        Ausgabe(Year, DayLightDate1,    DaylightBias);
        Ausgabe(Year, DoubleSummerDate, DoubleSummerBias);
        Ausgabe(Year, DayLightDate2,    DayLightBias);
        Ausgabe(Year, StandardDate,     StandardBias);
      end;
  end;

end.
